Package ru.bitel.bgbilling.plugins.dispatch.common.service

# Interface DispatchService

    @MTOM
    public interface DispatchService

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `addMessageInclusion​(DispatchMessage dm, javax.xml.ws.Holder<javax.activation.DataHandler> inclusion, java.lang.String fileName)` | Добавляет вложение в сообщение.
  `void` | `addSubscriptions​(java.lang.String dispatchIds, java.lang.String contractIds)` | Добавляет подписки на выбранные рассылки в выбранные договоры.
  `void` | `deleteContact​(int id)` | Удаляет контакт.
  `void` | `deleteContactType​(int contactTypeId)` | Удаляет тип контакта.
  `void` | `deleteDispatch​(Dispatch d)` | Удаляет рассылку.
  `void` | `deleteMessage​(DispatchMessage dm)` | Удаление сообщения из рассылки.
  `void` | `deleteMessageInclusion​(DispatchMessage dm, BGServerFile inclusion)` | Удаляет вложение из сообщения.
  `void` | `deleteSenderType​(int id)` | Удаляет метод отправки по его коду
  `void` | `deleteSubscription​(int subscriptionId)` | Удаляет подписку
  `java.util.List<Subscription>` | `getActiveSubscriptions​(int dispatchId)` | Возвращает список подписок
  `java.util.List<IdTitle>` | `getAddressParamList()` | Получение списка адресных параметров, которые заведены в параметрах договорах.
  `java.lang.String` | `getContactDefaultValue​(int contactTypeId, int contractId)` |
  `java.util.List<Contact>` | `getContacts​(int contractId)` | Deprecated. Use `getContacts(int, Dispatch)` instead
  `java.util.List<Contact>` | `getContacts​(int contractId, Dispatch dispatch)` | Возвращает список контактов, в том числе контакты из параметров договора.
  `java.util.List<ContactType>` | `getContactTypes()` | Возвращает список типов контактов
  `java.util.List<ContractContact>` | `getContracts​(java.lang.String name, int typeId)` | Получение списка договоров по контакту
  `java.lang.String` | `getCustomConditionCheckerIfaceName()` | Получение имени интерфейса проверяльщика условия для пользовательского динамического класса.
  `java.util.List<Dispatch>` | `getDispatchList()` | Возвращает список всех рассылок.
  `java.util.List<BGServerFile>` | `getMessageInclusions​(DispatchMessage dispatchMessage)` | Возвращает список вложений в сообщение
  `java.util.List<DispatchMessage>` | `getMessageList​(int did, boolean onlyNotSent)` | Возвращает список сообщения для рассылки
  `SearchResult<DispatchMessageStatistic>` | `getMessageStatisticList​(int contractId, int dispatchId, int messageId, int contactId, Period period, Page page)` | Получение статистики отправленных сообщений по договору и/или рассылке, и/или сообщению, и/или контакту за определенный период.
  `java.lang.String` | `getSenderIfaceClassName()` | Возвращает имя интерфейса, который должен имплементировать новый создаваемый метод отправки
  `java.util.List<SenderType>` | `getSenderTypes()` | Возвращает методы отправки
  `java.util.List<Subscription>` | `getSubscriptions​(int dispatchId, int contractId)` | Возвращает список подписок
  `java.util.List<java.lang.String>` | `installedModuleList()` | Возвращает имена установленных модулей, сделано для обхода запрета "получения списка модулей"
  `void` | `setEventForSubscription​(int dispatchId, int contractId)` | Устанавливает подпискам договора флаг события
  `void` | `updateContact​(Contact current)` | Изменяет\создает новый контакт.
  `void` | `updateContactType​(ContactType current)` | Изменяет\создает тип контакта
  `void` | `updateDispatch​(Dispatch dispatch)` | Изменяет\создает рассылку
  `void` | `updateMessage​(DispatchMessage dm)` | Изменяет\создает сообщение
  `void` | `updateSenderType​(SenderType current)` | Изменяет метод отправки
  `void` | `updateSubscriptions​(Subscription subscription)` | Изменяет\создает подписку

- ## Method Details

  - ### getDispatchList

    java.util.List<Dispatch> getDispatchList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список всех рассылок.
    Returns:
      пустой список, если рассылки еще не были заведены
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getMessageList

    java.util.List<DispatchMessage> getMessageList​(int did, boolean onlyNotSent) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список сообщения для рассылки
    Parameters:
      `did` - код рассылки
      `onlyNotSent` - выбрать только неотправленные
    Returns:
      пустой список, если сообщений в рассылке еще нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateDispatch

    void updateDispatch​(Dispatch dispatch) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет\создает рассылку
    Parameters:
      `dispatch` - рассылка (id <= 0 для создания новой)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException` - если у существующей рассылки изменяется тип контактов

  - ### updateMessage

    void updateMessage​(DispatchMessage dm) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет\создает сообщение
    Parameters:
      `dm` - сообщение (id <= 0 для создания нового)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getMessageInclusions

    java.util.List<BGServerFile> getMessageInclusions​(DispatchMessage dispatchMessage) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список вложений в сообщение
    Parameters:
      `dispatchMessage` - сообщение
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### addMessageInclusion

    void addMessageInclusion​(DispatchMessage dm, javax.xml.ws.Holder<javax.activation.DataHandler> inclusion, java.lang.String fileName) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Добавляет вложение в сообщение. Нельзя добавлять вложения в отправленные сообщения.
    Parameters:
      `dm` - сообщение
      `inclusion` - данные для вложения
      `fileName` - имя вложения
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteMessageInclusion

    void deleteMessageInclusion​(DispatchMessage dm, BGServerFile inclusion) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаляет вложение из сообщения. Нельзя удалить вложение из отправленного сообщения.
    Parameters:
      `dm` - сообщение
      `inclusion` - вложение
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteDispatch

    void deleteDispatch​(Dispatch d) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаляет рассылку. Удаление рассылки приводит к удалению всех шаблонов рассылки, всех сообщений рассылки и всех подписок на эту рассылку.
    Parameters:
      `d` - рассылка
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteMessage

    void deleteMessage​(DispatchMessage dm) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаление сообщения из рассылки. Невозможно удалить отправленное сообщение, только если не установлен флаг allow.delete.sent.messages=1 в конфигурации плагина.
    Parameters:
      `dm` - сообщение
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateContactType

    void updateContactType​(ContactType current) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет\создает тип контакта
    Parameters:
      `current` - (id <= 0 для создания нового типа контакта)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteContactType

    void deleteContactType​(int contactTypeId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаляет тип контакта. Тип контакта может быть удален ТОЛЬКО если отсутствуют рассылки с таким типом.
    Parameters:
      `contactTypeId` - код типа контакта
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getContactTypes

    java.util.List<ContactType> getContactTypes() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список типов контактов
    Returns:
      пустой список, если типов контактов еще нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getContacts

    @RequestWrapper(className="ru.bitel.bgbilling.plugins.dispatch.common.jaxws.GetContactsOldRequest") @ResponseWrapper(className="ru.bitel.bgbilling.plugins.dispatch.common.jaxws.GetContactsOldResponse") @Deprecated java.util.List<Contact> getContacts​(int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Deprecated.
    Use `getContacts(int, Dispatch)` instead
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getContacts

    java.util.List<Contact> getContacts​(int contractId, Dispatch dispatch) throws ru.bitel.bgbilling.common.BGException
    Возвращает список контактов, в том числе контакты из параметров договора.
    Parameters:
      `contractId` - код договора
      `dispatch` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateContact

    void updateContact​(Contact current) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет\создает новый контакт. Осуществляется проверка на соответствие шаблону типа контакта.
    Parameters:
      `current` - контакт (id <= 0 для созданиея нового)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException` - если проверка значения контакта по шаблону типа контакта не прошла

  - ### deleteContact

    void deleteContact​(int id) throws ru.bitel.bgbilling.common.BGException
    Удаляет контакт. Проверяет наличие подписок для контакта перед удалением.
    Parameters:
      `id` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException` - если контакт подписан на рассылки

  - ### getContactDefaultValue

    java.lang.String getContactDefaultValue​(int contactTypeId, int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getSubscriptions

    java.util.List<Subscription> getSubscriptions​(int dispatchId, int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список подписок
    Parameters:
      `dispatchId` - если 0, то возвращает список всех подписок для договора
      `contractId` - если 0, то возвращает список всех подписок на рассылку
    Returns:
      пустой список, если таковых нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getActiveSubscriptions

    java.util.List<Subscription> getActiveSubscriptions​(int dispatchId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает список подписок
    Parameters:
      `dispatchId` - если 0, то возвращает список всех подписок для договора
    Returns:
      пустой список, если таковых нет
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteSubscription

    void deleteSubscription​(int subscriptionId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаляет подписку
    Parameters:
      `subscriptionId` - код подписки
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### updateSubscriptions

    void updateSubscriptions​(Subscription subscription) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет\создает подписку
    Parameters:
      `subscription` - (id <= 0 для создания новой)
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException` - если в подписке нет контактов

  - ### addSubscriptions

    void addSubscriptions​(java.lang.String dispatchIds, java.lang.String contractIds) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Добавляет подписки на выбранные рассылки в выбранные договоры. Используется в групповой операции. Подписка добавится только в том случае, если в договоре заведен контакт (-ы) с таким же типом контакта, который указан в рассылке.
    Parameters:
      `dispatchIds` - список кодов рассылок через запятую.
      `contractIds` - список кодов договоров через запятую, которым следует добавить подписки на рассылки.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getSenderTypes

    java.util.List<SenderType> getSenderTypes() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает методы отправки
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getSenderIfaceClassName

    java.lang.String getSenderIfaceClassName()
    Возвращает имя интерфейса, который должен имплементировать новый создаваемый метод отправки
    Returns:

  - ### updateSenderType

    void updateSenderType​(SenderType current) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Изменяет метод отправки
    Parameters:
      `current` - создает при id <= 0
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### deleteSenderType

    void deleteSenderType​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Удаляет метод отправки по его коду
    Parameters:
      `id` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getAddressParamList

    java.util.List<IdTitle> getAddressParamList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение списка адресных параметров, которые заведены в параметрах договорах. ИСпользуется в условии отправки по адресу подписчика
    Returns:
      список адресных параметров в виде `IdTitle`
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getContracts

    java.util.List<ContractContact> getContracts​(java.lang.String name, int typeId)
    Получение списка договоров по контакту
    Parameters:
      `name` - Строка для поиска
      `typeId` - Id типа контакта
    Returns:

  - ### getCustomConditionCheckerIfaceName

    java.lang.String getCustomConditionCheckerIfaceName()
    Получение имени интерфейса проверяльщика условия для пользовательского динамического класса.
    Returns:
      полное имя интерфейса, включая имя пакета.

  - ### setEventForSubscription

    void setEventForSubscription​(int dispatchId, int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Устанавливает подпискам договора флаг события
    Parameters:
      `dispatchId` - код рассылки
      `contractId` - ид договора
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getMessageStatisticList

    SearchResult<DispatchMessageStatistic> getMessageStatisticList​(int contractId, int dispatchId, int messageId, int contactId, Period period, Page page) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Получение статистики отправленных сообщений по договору и/или рассылке, и/или сообщению, и/или контакту за определенный период.
    Parameters:
      `contractId` - код договора
      `dispatchId` - код рассылки
      `messageId` - код сообщения из рассылки
      `contactId` - код контакта плагина
      `period` - период, за который нужно вывести статистику
      `page` - отображаемая страница
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### installedModuleList

    java.util.List<java.lang.String> installedModuleList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Возвращает имена установленных модулей, сделано для обхода запрета "получения списка модулей"
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`